<?php
/**
 * @version		1.0
 * @package		Joomla
 * @subpackage	Event Booking
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );
jimport( 'joomla.application.component.controller' );
/**
 * EventBooking controller
 *
 * @package		Joomla
 * @subpackage	Event Booking
 * @since 1.5
 */
class EventBookingController extends JController
{
	/**
	 * Constructor function
	 *
	 * @param array $config
	 */
	function __construct($config = array())
	{
		parent::__construct($config);			
	}
	/**
	 * Display information
	 *
	 */
	function display( )
	{	
		$task = $this->getTask();		
		switch ($task) {							
			case 'show_configuration':
				JRequest::setVar('view', 'configuration');
				break;								
			case 'show_categories' :
				JRequest::setVar('view', 'categories');
				break ;		
			case 'edit_category' :
				JRequest::setVar('view', 'category');
				JRequest::setVar('edit', true) ;
				break ;				
			case 'new_category' :
				JRequest::setVar('view', 'category');
				JRequest::setVar('edit', false) ;
				break ;		
			case 'show_locations' :
				JRequest::setVar('view', 'locations');
				break ;		
			case 'edit_location' :
				JRequest::setVar('view', 'location');
				JRequest::setVar('edit', true) ;
				break ;				
			case 'add_location' :
				JRequest::setVar('view', 'location');
				JRequest::setVar('edit', false) ;
				break ;	
			case 'show_fields':
				JRequest::setVar('view', 'fields');
				break;
			case 'add_field':
				JRequest::setVar( 'hidemainmenu', 1 );				
				JRequest::setVar( 'view'  , 'field');
				JRequest::setVar( 'edit', false );
				break;	
			case 'edit_field':
				JRequest::setVar( 'hidemainmenu', 1 );				
				JRequest::setVar( 'view'  , 'field');
				JRequest::setVar( 'edit', true );
				break;														
			case 'show_events':
				JRequest::setVar('view', 'events');
				break;	
			case 'add_event'     :			
				JRequest::setVar( 'hidemainmenu', 1 );				
				JRequest::setVar( 'view'  , 'event');
				JRequest::setVar( 'edit', false );				
			 	break;			
			case 'edit_event'    :			
				JRequest::setVar( 'hidemainmenu', 1 );
				JRequest::setVar('view', 'event');								
				JRequest::setVar( 'edit', true );				
				break;																							
			case 'show_registrants' :
				JRequest::setVar('view', 'registrants');
				break;
			case 'add_registrant':
				JRequest::setVar( 'hidemainmenu', 1 );				
				JRequest::setVar( 'view'  , 'registrant');
				JRequest::setVar( 'edit', false );
				break;	
			case 'edit_registrant':
				JRequest::setVar( 'hidemainmenu', 1 );				
				JRequest::setVar( 'view'  , 'registrant');
				JRequest::setVar( 'edit', true );
				break;			
			case 'email_registrants' :
				JRequest::setVar('view', 'email') ;
				break ;	
			case 'edit_members' :
				JRequest::setVar('view', 'members') ;
				break ;
			case 'show_translation' :
				JRequest::setVar('view', 'language') ;
				break ;	
			case 'show_plugins' :
				JRequest::setVar('view', 'plugins') ;
				break ;				
			case 'edit_plugin' :
				JRequest::setVar('view', 'plugin') ;
				JRequest::setVar('hidemainmenu', 1) ;
				JRequest::setVar('edit', true) ;
				break ;	
			default:
				JRequest::setVar('view', 'events') ;
				break ;																															
		}
		parent::display();
		EventBookingHelper::displayCopyRight();
	}
	/**
	 * Save configuration data
	 *
	 */	
	function save_configuration() {
		$data = JRequest::get('post', JREQUEST_ALLOWHTML) ;
		unset($data['option']) ;
		unset($data['task']) ;							
		if (isset($data['payment_methods']) && is_array($data['payment_methods']))
			$data['payment_methods'] = implode(',', $data['payment_methods']);																									
		$model = & $this->getModel('configuration');
		$ret = $model->store($data);
		if ($ret) {
			$msg = JText::_('Configuration data saved');
		} else {
			$msg =  JText::_('Error saving configuration data');
		}
		$this->setRedirect('index.php?option=com_eventbooking&task=show_configuration', $msg);
	}	
	/**
	 * Save the category
	 *
	 */
	function save_category() {
		$post = JRequest::get('post' , JREQUEST_ALLOWHTML);
		$model =  $this->getModel('category') ;
		$cid = $post['cid'];
		$post['id'] = (int) $cid[0];
		$ret =  $model->store($post);
		if ($ret) {
			$msg = JText::_('Successfully saving category');	
		} else {
			$msg = JText::_('Error while saving category') ;
		}
		$this->setRedirect('index.php?option=com_eventbooking&task=show_categories', $msg);
	}
	/**
	 * Save ordering of the selected category
	 *
	 */
	function save_category_order() {
		$order = JRequest::getVar('order', array(), 'post') ;
		$cid = JRequest::getVar('cid', array(), 'post') ;
		JArrayHelper::toInteger($order);
		JArrayHelper::toInteger($cid);
		$model = & $this->getModel('category');
		$ret = $model->saveOrder($cid, $order);
		if ($ret) {
			$msg = JText::_('Ordering saved') ; 
		} else {
			$msg = JText::_('Error saving ordering') ;
		}
		$this->setRedirect('index.php?option=com_eventbooking&task=show_categories', $msg);
	}
	/**
	 * Order up a category
	 *
	 */
	function orderup_category() {
		$model =  $this->getModel('category');
		$model->move(-1);		 			
		$msg = JText::_('Ordering updated');			
		$url = 'index.php?option=com_eventbooking&task=show_categories';
		$this->setRedirect($url, $msg);
	}
	/**
	 * Order down a category
	 *
	 */
	function orderdown_category() {
		$model =  $this->getModel('category');
		$model->move(1);		 			
		$msg = JText::_('Ordering updated');			
		$url = 'index.php?option=com_eventbooking&task=show_categories';
		$this->setRedirect($url, $msg);
	}	
	/**
	 * Removing categories
	 *
	 */
	function remove_categories() {
		$model =  $this->getModel('category');
		$cid = JRequest::getVar('cid', array()) ;
		JArrayHelper::toInteger($cid);
		$model->delete($cid);
		$msg = JText::_('categories Removed');			
		$url = 'index.php?option=com_eventbooking&task=show_categories';
		$this->setRedirect($url, $msg);
	}	
	/**
	 * Unpublish categories
	 *
	 */		
	function categories_publish() {
		$cid = JRequest::getVar('cid', array(), 'post');
		JArrayHelper::toInteger($cid);
		$model = & $this->getModel('category');
		$ret = $model->publish($cid, 1);
		if ($ret) 
			$msg = JText::_('Categories published');
		else
			$msg = JText::_('Error while publishing categories');		
		$this->setRedirect('index.php?option=com_eventbooking&task=show_categories', $msg);		
	}
	/**
	 * Publish categories
	 *
	 */
	function categories_unpublish() {
		$cid = JRequest::getVar('cid', array(), 'post');
		JArrayHelper::toInteger($cid);
		$model = & $this->getModel('category');
		$ret = $model->publish($cid, 0);
		if ($ret) 
			$msg = JText::_('Categories unpublished');
		else
			$msg = JText::_('Error while unpublishing categories');		
		$this->setRedirect('index.php?option=com_eventbooking&task=show_categories', $msg);
	}	
	function copy_category() {
		$cid = JRequest::getVar('cid', array(), 'post') ;
		JArrayHelper::toInteger($cid);
		$id = $cid[0] ;
		$model = $this->getModel('category') ;
		$model->copy($id);
		$msg = JText::_('Category successfully copied') ;
		$this->setRedirect('index.php?option=com_eventbooking&task=show_categories', $msg);
	}
	/**
	 * Cancel the category . Redirect user to categories list page
	 *
	 */
	function cancel_category() {
		$this->setRedirect('index.php?option=com_eventbooking&task=show_categories');
	}	
	/**
	 * Save event
	 *
	 */	
	function save_event() {
		$post = JRequest::get('post' , JREQUEST_ALLOWHTML);
		$model =  $this->getModel('event') ;
		$cid = $post['cid'];
		$post['id'] = (int) $cid[0];
		$ret =  $model->store($post);
		if ($ret) {
			$msg = JText::_('Successfully saving event');	
		} else {
			$msg = JText::_('Error while saving event') ;
		}
		$this->setRedirect('index.php?option=com_eventbooking&task=show_events', $msg);
	}
	/**
	 * Copy a field
	 *
	 */
	function copy_event() {
		$cid = JRequest::getVar('cid', null) ;
		JArrayHelper::toInteger($cid);
		$id = $cid[0] ;
		$model = $this->getModel('event') ;
		$newEventId =  $model->copy($id);		
		$this->setRedirect('index.php?option=com_eventbooking&task=edit_event&cid[]='.$newEventId, JText::_('Event was successfully copied'));	
	}
	/**
	 * Remove selected events
	 *
	 */	
	function remove_events() {
		$cid = JRequest::getVar('cid', null);
		JArrayHelper::toInteger($cid);
		$model = $this->getModel('event');
		$ret = $model->delete($cid);
		if ($ret) {
			$msg = JText::_('Successfully removing events'); 
		} else {
			$msg = JText::_('Error while removing events');
		}
		$this->setRedirect('index.php?option=com_eventbooking&task=show_events', $msg);
	}
	/**
	 * Publish the selected events
	 *
	 */
	function events_publish() {
		$cid = JRequest::getVar('cid', null) ;
		JArrayHelper::toInteger($cid);
		$model = $this->getModel('event') ;
		$ret =  $model->publish($cid, 1);
		if ($ret) {
			$msg = JText::_('Events successfully published'); 
		} else {
			$msg = JText::_('Error while publishing events');
		}
		$this->setRedirect('index.php?option=com_eventbooking&task=show_events', $msg);
	}
	/**
	 * Unpublish the selected events
	 *
	 */
	function events_unpublish() {
		$cid = JRequest::getVar('cid', null) ;
		JArrayHelper::toInteger($cid);
		$model = $this->getModel('event') ;
		$ret =  $model->publish($cid, 0);
		if ($ret) {
			$msg = JText::_('Events successfully unpublished'); 
		} else {
			$msg = JText::_('Error while unpublishing events');
		}
		$this->setRedirect('index.php?option=com_eventbooking&task=show_events', $msg);
	}
	/**
	 * Redirect user to events mangement page
	 *
	 */
	function cancel_event() {
		$this->setRedirect('index.php?option=com_eventbooking&task=show_events');
	}
	/**
	 * Save ordering of the selected category
	 *
	 */
	function save_event_order() {
		$order = JRequest::getVar('order', array(), 'post') ;
		$cid = JRequest::getVar('cid', array(), 'post') ;
		JArrayHelper::toInteger($order);
		JArrayHelper::toInteger($cid);
		$model = & $this->getModel('event');
		$ret = $model->saveOrder($cid, $order);
		if ($ret) {
			$msg = JText::_('Ordering saved') ; 
		} else {
			$msg = JText::_('Error saving ordering') ;
		}
		$this->setRedirect('index.php?option=com_eventbooking&task=show_events', $msg);
	}
	/**
	 * Order up a category
	 *
	 */
	function orderup_event() {
		$model =  $this->getModel('event');
		$model->move(-1);		 			
		$msg = JText::_('Ordering updated');			
		$url = 'index.php?option=com_eventbooking&task=show_events';
		$this->setRedirect($url, $msg);
	}
	/**
	 * Order down a category
	 *
	 */
	function orderdown_event() {
		$model =  $this->getModel('event');
		$model->move(1);		 			
		$msg = JText::_('Ordering updated');			
		$url = 'index.php?option=com_eventbooking&task=show_events';
		$this->setRedirect($url, $msg);
	}	
	/**
	 * Save field
	 *
	 */
	function save_field() {
		$post = JRequest::get('post' , JREQUEST_ALLOWHTML);
		$model =  $this->getModel('field') ;
		$cid = $post['cid'];
		$post['id'] = (int) $cid[0];
		$ret =  $model->store($post);
		if ($ret) {
			$msg = JText::_('Successfully saving field');	
		} else {
			$msg = JText::_('Error while saving field') ;
		}
		$this->setRedirect('index.php?option=com_eventbooking&task=show_fields', $msg);
	}
	/**
	 * Remove selected fields
	 *
	 */	
	function remove_fields() {
		$cid = JRequest::getVar('cid', null);
		JArrayHelper::toInteger($cid);
		$model = $this->getModel('field');
		$ret = $model->delete($cid);
		if ($ret) {
			$msg = JText::_('Successfully removing fields'); 
		} else {
			$msg = JText::_('Error while removing fields');
		}
		$this->setRedirect('index.php?option=com_eventbooking&task=show_fields', $msg);
	}
	/**
	 * Publish the selected fields
	 *
	 */
	function fields_publish() {
		$cid = JRequest::getVar('cid', null) ;
		JArrayHelper::toInteger($cid);
		$model = $this->getModel('field');
		$ret = $model->publish($cid , 1);
		if ($ret) {
			$msg = JText::_('Fields successfully published'); 
		} else {
			$msg = JText::_('Error while publishing fields');
		}
		$this->setRedirect('index.php?option=com_eventbooking&task=show_fields', $msg);
	}
	/**
	 * Unpublish the selected fields
	 *
	 */
	function fields_unpublish() {
		$cid = JRequest::getVar('cid', null) ;
		JArrayHelper::toInteger($cid);
		$model = $this->getModel('field') ;
		$ret =  $model->publish($cid, 0);
		if ($ret) {
			$msg = JText::_('Fields successfully unpublished'); 
		} else {
			$msg = JText::_('Error while unpublishing fields');
		}
		$this->setRedirect('index.php?option=com_eventbooking&task=show_fields', $msg);
	}
	/**
	 * Copy a field
	 *
	 */
	function copy_field() {
		$cid = JRequest::getVar('cid', null) ;
		JArrayHelper::toInteger($cid);
		$id = $cid[0] ;
		$model = $this->getModel('field') ;
		$newFieldId =  $model->copy($id);		
		$this->setRedirect('index.php?option=com_eventbooking&task=edit_field&cid[]='.$newFieldId, JText::_('Field was successfully copied'));	
	}
	/**
	 * Require the selected fields
	 *
	 */
	function required() {
		$cid = JRequest::getVar('cid', null) ;
		JArrayHelper::toInteger($cid);
		$model = $this->getModel('field');
		$ret = $model->required($cid , 1);
		if ($ret) {
			$msg = JText::_('Required status successfully change'); 
		} else {
			$msg = JText::_('Error while changing required status');
		}
		$this->setRedirect('index.php?option=com_eventbooking&task=show_fields', $msg);
	}
	
	/**
	 * Change status to un required
	 *
	 */
	function un_required() {
		$cid = JRequest::getVar('cid', null) ;
		JArrayHelper::toInteger($cid);
		$model = $this->getModel('field');
		$ret = $model->required($cid , 0);
		if ($ret) {
			$msg = JText::_('Required status successfully change'); 
		} else {
			$msg = JText::_('Error while changing required status');
		}
		$this->setRedirect('index.php?option=com_eventbooking&task=show_fields', $msg);
	}
	/**
	 * Order up custom field
	 *
	 */
	function orderup_field() {
		$model =  $this->getModel('field');
		$model->move(-1);		 			
		$msg = JText::_('Ordering updated');			
		$url = 'index.php?option=com_eventbooking&task=show_fields';
		$this->setRedirect($url, $msg);
	}
	/**
	 * Order down a custom field
	 *
	 */
	function orderdown_field() {
		$model =  $this->getModel('field');
		$model->move(1);		 			
		$msg = JText::_('Ordering updated');			
		$url = 'index.php?option=com_eventbooking&task=show_fields';
		$this->setRedirect($url, $msg);
	}
	/**
	 * Redirect user to fields mangement page
	 *
	 */
	function cancel_field() {
		$this->setRedirect('index.php?option=com_eventbooking&task=show_fields');
	}				
	/**
	 * Export data to csv file
	 *
	 */
	/*function csv_export() {
		$db = & JFactory::getDBO();
		$config = EventBookingHelper::getConfig();
		$eventId = JRequest::getInt('event_id') ;
		$where = array() ;		
		$where[] = '(a.published = 1 OR a.payment_method="os_offline")' ;
		if ($eventId)
			$where[] = ' a.event_id='.$eventId ;
		$sql = 'SELECT a.*, b.event_date, b.title AS event_title FROM #__eb_registrants AS a INNER JOIN #__eb_events AS b on a.event_id = b.id WHERE '.implode(' AND ', $where);
		$db->setQuery($sql) ;		
		$rows  = $db->loadObjectList();
		if ($eventId)
			$sql = 'SELECT id, title FROM #__eb_fields WHERE published=1 AND (event_id = 0 OR event_id='.$eventId.') ORDER BY ordering';
		else 
			$sql = 'SELECT id, title FROM #__eb_fields WHERE published=1  ORDER BY ordering';
		$db->setQuery($sql) ;
		$rowFields = $db->loadObjectList() ;					
		//Get the custom fields value and store them into an array
				
		$sql = 'SELECT id FROM #__eb_registrants AS a WHERE '.implode(' AND ', $where) ; 
		$db->setQuery($sql) ;		
		$registrantIds = array(0) ;
		$registrantIds = array_merge($registrantIds, $db->loadResultArray()) ;
		$sql = 'SELECT registrant_id, field_id, field_value FROM #__eb_field_values WHERE registrant_id IN ('.implode(',', $registrantIds).')';
		$db->setQuery($sql) ;
		$rowFieldValues = $db->loadObjectList();
		$fieldValues = array() ;
		for ($i = 0 , $n = count($rowFieldValues) ; $i < $n ; $i++) {
			$rowFieldValue = $rowFieldValues[$i] ;
			$fieldValues[$rowFieldValue->registrant_id][$rowFieldValue->field_id] = $rowFieldValue->field_value ;
		}							
		if(count($rows)){			
			$results_arr=array();				
			$csv_output = "Event";
			if ($config->show_event_date) {
				$csv_output .= ", Event Date " ;
			}
			$csv_output .= ", First name " ;
			if ($config->s_lastname)
				$csv_output .= ", Last name";		
			if ($config->s_organization) 
				$csv_output .= ', Organization ';
			if ($config->s_address)
				$csv_output .= ', Address ';
			if ($config->s_address2)
				$csv_output .= ', Address2 ';	
			if ($config->s_city)
				$csv_output .= ', City ';
			if ($config->s_state)
				$csv_output .= ', State ';			
			if ($config->s_zip)
				$csv_output .= ', Zip ';
			if ($config->s_country)
				$csv_output .= ', Country ';
			if ($config->s_phone)
				$csv_output .= ', Phone ';			
			if ($config->s_fax)
				$csv_output .= ', Fax ';	
			$csv_output .= ', Email ';
			$csv_output .= ', Number Registrants ';									
			$csv_output .= ', Amount ';			
			$csv_output .= ', Registration Date ';
			$csv_output .= ', Transaction Id ';	
			if (count($rowFields)) {
				foreach ($rowFields as  $rowField) 
					$csv_output .= ', '.$rowField->title ;	
			}			
			if ($config->s_comment)
				$csv_output .= ', Comment ';				
			foreach($rows as $r) {
				$results_arr=array();
				$results_arr[]=$r->event_title ;
				if ($config->show_event_date) {
					$results_arr[] = JHTML::_('date', $r->event_date, $config->date_format) ;															
				}
				$results_arr[]=$r->first_name ;
				if ($config->s_lastname)
					$results_arr[]=$r->last_name ;
				if ($config->s_organization)
					$results_arr[]=$r->organization;
				if ($config->s_address)
					$results_arr[]=$r->address;
				if ($config->s_address2)
					$results_arr[]=$r->address2;	
				if ($config->s_city)
					$results_arr[]=$r->city;
				if ($config->s_state)
					$results_arr[]=$r->state;	
				if ($config->s_zip)
					$results_arr[]=$r->zip;
				if ($config->s_country)
					$results_arr[]=$r->country;
				if ($config->s_phone)
					$results_arr[]=$r->phone;								
				if ($config->s_fax)
					$results_arr[]=$r->fax;	
				$results_arr[]=$r->email;		
				$results_arr[] = $r->number_registrants ;						
				$results_arr[]= number_format($r->amount, 2);																				
				$results_arr[]= JHTML::_('date', $r->register_date, $config->date_format);							
				$results_arr[]= $r->transaction_id ;	
				if (count($rowFields))
					foreach ($rowFields as $rowField) {
						$results_arr[] = @$fieldValues[$r->id][$rowField->id] ;						
					}
				if ($config->s_comment)
					$results_arr[]= $r->comment;																				
				$csv_output .= "\n\"".implode ("\",\"", $results_arr)."\"";				
			}
			$csv_output .= "\n";	
			if (ereg('Opera(/| )([0-9].[0-9]{1,2})', $_SERVER['HTTP_USER_AGENT'])) {
				$UserBrowser = "Opera";
			}
			elseif (ereg('MSIE ([0-9].[0-9]{1,2})', $_SERVER['HTTP_USER_AGENT'])) {	
				$UserBrowser = "IE";
			} else {
				$UserBrowser = '';	}	
				$mime_type = ($UserBrowser == 'IE' || $UserBrowser == 'Opera') ? 'application/octetstream' : 'application/octet-stream';
				$filename = "registrants_list";	
				@ob_end_clean();	
				ob_start();	
				header('Content-Type: ' . $mime_type);	
				header('Expires: ' . gmdate('D, d M Y H:i:s') . ' GMT');	
				if ($UserBrowser == 'IE') {
					header('Content-Disposition: attachment; filename="' . $filename . '.csv"');
					header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
					header('Pragma: public');
				}
				else {
					header('Content-Disposition: attachment; filename="' . $filename . '.csv"');
					header('Pragma: no-cache');
				}
				print $csv_output;
				exit();
		}	
	}
	*/
	function csv_export() {
		$db = & JFactory::getDBO();
		$config = EventBookingHelper::getConfig();
		$eventId = JRequest::getInt('event_id') ;
		$where = array() ;		
		$where[] = '(a.published = 1 OR a.payment_method="os_offline")' ;
		if ($eventId)
			$where[] = ' a.event_id='.$eventId ;		
		$sql = 'SELECT id FROM #__eb_registrants AS a WHERE number_registrants > 1 AND '.implode('AND', $where);
		$db->setQuery($sql) ;
		$groupIds = $db->loadResultArray();
		print_r($groupIds);
		if (count($groupIds)) {
			$sql = 'SELECT id FROM #__eb_registrants WHERE group_id IN ('.implode(',', $groupIds).')';
			$db->setQuery($sql) ;
			$memberIds = $db->loadResultArray();
		} else {
			$memberIds = array() ;
		}			
		if (count($memberIds) == 0) {
			$memberIds[]= 0 ;		
		}		
		$sql = 'SELECT a.*, b.event_date, b.title AS event_title FROM #__eb_registrants AS a INNER JOIN #__eb_events AS b on a.event_id = b.id WHERE '.implode(' AND ', $where).' OR a.id IN('.implode(',', $memberIds).')';
		$db->setQuery($sql) ;		
		$rows  = $db->loadObjectList();							
		if ($eventId)
			$sql = 'SELECT id, title FROM #__eb_fields WHERE published=1 AND (event_id = 0 OR event_id='.$eventId.') ORDER BY ordering';
		else 
			$sql = 'SELECT id, title FROM #__eb_fields WHERE published=1  ORDER BY ordering';
		$db->setQuery($sql) ;
		$rowFields = $db->loadObjectList() ;					
		//Get the custom fields value and store them into an array
				
		$sql = 'SELECT id FROM #__eb_registrants AS a WHERE '.implode(' AND ', $where) ; 
		$db->setQuery($sql) ;		
		$registrantIds = array(0) ;
		$registrantIds = array_merge($registrantIds, $db->loadResultArray()) ;
		$registrantIds = array_merge($registrantIds, $memberIds) ;
		$sql = 'SELECT registrant_id, field_id, field_value FROM #__eb_field_values WHERE registrant_id IN ('.implode(',', $registrantIds).')';
		$db->setQuery($sql) ;
		$rowFieldValues = $db->loadObjectList();
		$fieldValues = array() ;
		for ($i = 0 , $n = count($rowFieldValues) ; $i < $n ; $i++) {
			$rowFieldValue = $rowFieldValues[$i] ;
			$fieldValues[$rowFieldValue->registrant_id][$rowFieldValue->field_id] = $rowFieldValue->field_value ;
		}							
		if(count($rows)){			
			$results_arr=array();				
			$csv_output = "Event";
			if ($config->show_event_date) {
				$csv_output .= ", Event Date " ;
			}
			$csv_output .= ", First name " ;
			if ($config->s_lastname)
				$csv_output .= ", Last name";		
			if ($config->s_organization) 
				$csv_output .= ', Organization ';
			if ($config->s_address)
				$csv_output .= ', Address ';
			if ($config->s_address2)
				$csv_output .= ', Address2 ';	
			if ($config->s_city)
				$csv_output .= ', City ';
			if ($config->s_state)
				$csv_output .= ', State ';			
			if ($config->s_zip)
				$csv_output .= ', Zip ';
			if ($config->s_country)
				$csv_output .= ', Country ';
			if ($config->s_phone)
				$csv_output .= ', Phone ';			
			if ($config->s_fax)
				$csv_output .= ', Fax ';	
			$csv_output .= ', Email ';
			$csv_output .= ', Number Registrants ';									
			$csv_output .= ', Amount ';			
			$csv_output .= ', Registration Date ';
			$csv_output .= ', Transaction Id ';	
			if (count($rowFields)) {
				foreach ($rowFields as  $rowField) 
					$csv_output .= ', '.$rowField->title ;	
			}			
			if ($config->s_comment)
				$csv_output .= ', Comment ';				
			foreach($rows as $r) {
				//TODO: Should we add this command
				/*
				if ($r->number_registrants > 2)
					continue ;
				*/	
				$results_arr=array();
				$results_arr[]=$r->event_title ;
				if ($config->show_event_date) {
					$results_arr[] = JHTML::_('date', $r->event_date, $config->date_format) ;															
				}
				$results_arr[]=$r->first_name ;
				if ($config->s_lastname)
					$results_arr[]=$r->last_name ;
				if ($config->s_organization)
					$results_arr[]=$r->organization;
				if ($config->s_address)
					$results_arr[]=$r->address;
				if ($config->s_address2)
					$results_arr[]=$r->address2;	
				if ($config->s_city)
					$results_arr[]=$r->city;
				if ($config->s_state)
					$results_arr[]=$r->state;	
				if ($config->s_zip)
					$results_arr[]=$r->zip;
				if ($config->s_country)
					$results_arr[]=$r->country;
				if ($config->s_phone)
					$results_arr[]=$r->phone;								
				if ($config->s_fax)
					$results_arr[]=$r->fax;	
				$results_arr[]=$r->email;		
				$results_arr[] = $r->number_registrants ;						
				$results_arr[]= number_format($r->amount, 2);																				
				$results_arr[]= JHTML::_('date', $r->register_date, $config->date_format);							
				$results_arr[]= $r->transaction_id ;	
				if (count($rowFields))
					foreach ($rowFields as $rowField) {
						$results_arr[] = @$fieldValues[$r->id][$rowField->id] ;						
					}
				if ($config->s_comment)
					$results_arr[]= $r->comment;																				
				$csv_output .= "\n\"".implode ("\",\"", $results_arr)."\"";				
			}
			$csv_output .= "\n";	
			if (ereg('Opera(/| )([0-9].[0-9]{1,2})', $_SERVER['HTTP_USER_AGENT'])) {
				$UserBrowser = "Opera";
			}
			elseif (ereg('MSIE ([0-9].[0-9]{1,2})', $_SERVER['HTTP_USER_AGENT'])) {	
				$UserBrowser = "IE";
			} else {
				$UserBrowser = '';	}	
				$mime_type = ($UserBrowser == 'IE' || $UserBrowser == 'Opera') ? 'application/octetstream' : 'application/octet-stream';
				$filename = "registrants_list";	
				@ob_end_clean();	
				ob_start();	
				header('Content-Type: ' . $mime_type);	
				header('Expires: ' . gmdate('D, d M Y H:i:s') . ' GMT');	
				if ($UserBrowser == 'IE') {
					header('Content-Disposition: attachment; filename="' . $filename . '.csv"');
					header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
					header('Pragma: public');
				}
				else {
					header('Content-Disposition: attachment; filename="' . $filename . '.csv"');
					header('Pragma: no-cache');
				}
				print $csv_output;
				exit();
		}	
	}		
	/**
	 * Save the location
	 *
	 */
	function save_location() {
		$post = JRequest::get('post' , JREQUEST_ALLOWHTML);
		$model =  $this->getModel('location') ;
		$cid = $post['cid'];
		$post['id'] = (int) $cid[0];
		$ret =  $model->store($post);
		if ($ret) {
			$msg = JText::_('Successfully saving location');	
		} else {
			$msg = JText::_('Error while saving location') ;
		}
		$this->setRedirect('index.php?option=com_eventbooking&task=show_locations', $msg);
	}	
	/**
	 * Removing locations
	 *
	 */
	function remove_locations() {
		$model =  $this->getModel('location');
		$cid = JRequest::getVar('cid', array()) ;
		JArrayHelper::toInteger($cid);
		$model->delete($cid);
		$msg = JText::_('Locations Removed');			
		$url = 'index.php?option=com_eventbooking&task=show_locations';
		$this->setRedirect($url, $msg);
	}	
	/**
	 * Unpublish Locations
	 *
	 */		
	function locations_publish() {
		$cid = JRequest::getVar('cid', array(), 'post');
		JArrayHelper::toInteger($cid);
		$model = & $this->getModel('location');
		$ret = $model->publish($cid, 1);
		if ($ret) 
			$msg = JText::_('Locations published');
		else
			$msg = JText::_('Error while publishing locations');		
		$this->setRedirect('index.php?option=com_eventbooking&task=show_locations', $msg);		
	}
	/**
	 * Publish Locations
	 *
	 */
	function locations_unpublish() {
		$cid = JRequest::getVar('cid', array(), 'post');
		JArrayHelper::toInteger($cid);
		$model = & $this->getModel('location');
		$ret = $model->publish($cid, 0);
		if ($ret) 
			$msg = JText::_('Locations unpublished');
		else
			$msg = JText::_('Error while unpublishing locations');		
		$this->setRedirect('index.php?option=com_eventbooking&task=show_locations', $msg);
	}	
	/**
	 * Cancel the location . Redirect user to locations list page
	 *
	 */
	function cancel_location() {
		$this->setRedirect('index.php?option=com_eventbooking&task=show_locations');
	}
	/**
	 * Cancel editing/adding registrant. Redirect users to registrants management screen
	 *
	 */
	function cancel_registrant() {
		$this->setRedirect('index.php?option=com_eventbooking&task=show_registrants');
	}	
	/**
	 * Save the registrants
	 *
	 */
	function save_registrant() {
		$post = JRequest::get('post' , JREQUEST_ALLOWHTML);
		$model =  $this->getModel('registrant') ;
		$cid = $post['cid'];
		$post['id'] = (int) $cid[0];
		$ret =  $model->store($post);
		if ($ret) {
			$msg = JText::_('Successfully saving registrant');	
		} else {
			$msg = JText::_('Error while saving registrant') ;
		}
		$this->setRedirect('index.php?option=com_eventbooking&task=show_registrants', $msg);
	}	
	/**
	 * Removing locations
	 *
	 */
	function remove_registrants() {
		$model =  $this->getModel('registrant');
		$cid = JRequest::getVar('cid', array()) ;
		JArrayHelper::toInteger($cid);
		$model->delete($cid);
		$msg = JText::_('Registrants Removed');			
		$url = 'index.php?option=com_eventbooking&task=show_registrants';
		$this->setRedirect($url, $msg);
	}	
	/**
	 * Publish Registrants
	 *
	 */		
	function registrants_publish() {
		$cid = JRequest::getVar('cid', array(), 'post');
		JArrayHelper::toInteger($cid);
		$model = & $this->getModel('registrant');
		$ret = $model->publish($cid, 1);
		if ($ret) 
			$msg = JText::_('Registrants published');
		else
			$msg = JText::_('Error while publishing registrants');		
		$this->setRedirect('index.php?option=com_eventbooking&task=show_registrants', $msg);		
	}
	/**
	 * Unpublish registrants
	 *
	 */
	function registrants_unpublish() {
		$cid = JRequest::getVar('cid', array(), 'post');
		JArrayHelper::toInteger($cid);
		$model = & $this->getModel('registrant');
		$ret = $model->publish($cid, 0);
		if ($ret) 
			$msg = JText::_('Registrants unpublished');
		else
			$msg = JText::_('Error while unpublishing registrants');		
		$this->setRedirect('index.php?option=com_eventbooking&task=show_registrants', $msg);
	}
	/**
	 * Save members information for group registration
	 *
	 */	
	function save_members() {
		$post = JRequest::get('post', JREQUEST_ALLOWHTML); 
		$model = & $this->getModel('members') ;
		$model->store($post);
		$this->setRedirect('index.php?option=com_eventbooking&task=show_registrants', 'Member information saved');
	}
	/**
	 * Redirect users to registrants management page
	 *
	 */
	function cancel_member() {
		$this->setRedirect('index.php?option=com_eventbooking&task=show_registrants');
	}
	/**
	 * Save translation
	 *
	 */
	function save_translation() {
		$post = JRequest::get('post', JREQUEST_ALLOWHTML) ;
		$model = & $this->getModel('Language') ;
		$model->save($post);	
		$this->setRedirect('index.php?option=com_eventbooking&task=show_translation');	
	}
	/**
	 * Redirect user to translation management screen
	 *
	 */
	function cancel_translation() {
		$this->setRedirect('index.php?option=com_eventbooking&task=show_translation');
	}
/**
	 * Save plugin
	 *
	 */
	function save_plugin() {
		$model = & $this->getModel('plugin') ;
		$data = JRequest::get('post') ;
		$ret = $model->store($data);
		if ($ret) {
			$msg = JText::_('Plugin successfully saved') ;		
		} else {
			$msg = JText::_('Error while saving plugin') ;
		}
		$this->setRedirect( 'index.php?option=com_eventbooking&task=show_plugins', $msg);
	}	
	/**
	 * Install the plugin
	 *
	 */
	function install_plugin() {
		$model = & $this->getModel('plugin') ;
		$ret = $model->install();
		if ($ret) {
			$msg = JText::_('Plugin installed');
		} else {
			$msg = JRequest::getVar('msg', 'Error installing the plugin') ;
		}
		$this->setRedirect('index.php?option=com_eventbooking&task=show_plugins', $msg);		
	}
	/**
	 * Uninstall the selected plugin
	 *
	 */	
	function uninstall_plugin() {
		$model = & $this->getModel('plugin');
		$cid = JRequest::getVar('cid', array(), 'post', 'array') ;
		JArrayHelper::toInteger($cid);
		$ret = $model->uninstall($cid[0]);
		if ($ret) {
			$msg = JText::_('Plugin successfully uninstalled');	
		} else {
			$msg = JRequest::getVar('msg', 'Error uninstalling the plugin') ;
		}
		$this->setRedirect('index.php?option=com_eventbooking&task=show_plugins', $msg);		
	}
	/**
	 * Publish selected plugins
	 *
	 */
	function plugins_publish() {
		$model = & $this->getModel('plugin') ;
		$cid = JRequest::getVar('cid', array(), 'post', 'array') ;
		JArrayHelper::toInteger($cid);
		$ret = $model->publish($cid, 1) ;
		if ($ret) {
			$msg =  JText::_('Plugins successfully published');
		} else {
			$msg = JText::_('Error while publishing plugins');
		}
		$this->setRedirect('index.php?option=com_eventbooking&task=show_plugins', $msg);
	}
	/**
	 * Unpublish selected plugins
	 *
	 */
	function plugins_unpublish() {
		$model = & $this->getModel('plugin') ;
		$cid = JRequest::getVar('cid', array(), 'post', 'array') ;
		JArrayHelper::toInteger($cid);
		$ret = $model->publish($cid, 0) ;
		if ($ret) {
			$msg =  JText::_('Plugins successfully unpublished');
		} else {
			$msg = JText::_('Error while unpublishing plugins');
		}
		$this->setRedirect('index.php?option=com_eventbooking&task=show_plugins', $msg);
	}	
/**
	 * Save ordering of the selected category
	 *
	 */
	function save_plugin_order() {
		$order = JRequest::getVar('order', array(), 'post') ;
		$cid = JRequest::getVar('cid', array(), 'post') ;
		JArrayHelper::toInteger($order);
		JArrayHelper::toInteger($cid);
		$model = & $this->getModel('plugin');
		$ret = $model->saveOrder($cid, $order);
		if ($ret) {
			$msg = JText::_('Ordering saved') ; 
		} else {
			$msg = JText::_('Error saving ordering') ;
		}
		$this->setRedirect('index.php?option=com_eventbooking&task=show_plugins', $msg);
	}
	/**
	 * Order up a category
	 *
	 */
	function orderup_plugin() {
		$model =  $this->getModel('plugin');
		$model->move(-1);		 			
		$msg = JText::_('Ordering updated');			
		$url = 'index.php?option=com_eventbooking&task=show_plugins';
		$this->setRedirect($url, $msg);
	}
	/**
	 * Order down a category
	 *
	 */
	function orderdown_plugin() {
		$model =  $this->getModel('plugin');
		$model->move(1);		 			
		$msg = JText::_('Ordering updated');			
		$url = 'index.php?option=com_eventbooking&task=show_plugins';
		$this->setRedirect($url, $msg);
	}			
	/**
	 * Redirect to plugin management homepage
	 *
	 */
	function cancel_plugin() {
		$this->setRedirect('index.php?option=com_eventbooking&task=show_plugins');
	}
}